package com.yourkit.probes.builtin;

import com.yourkit.runtime.Callback;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * This class is not a probe class itself nor contains probe classes.
 * Instead, it provides a utility method to store arbitrary text messages.
 * They will be shown in "Event" tab as "Message".
 */
public final class Messages {
  /**
   * @param category free text description of message category,
   *    which can be used to filtering messages of different origin; must not be {@code null}
   * @param message free text; must not be {@code null}
   * @param detail additional description of the message; pass {@code null} for no description
   */
  public static void message(
    @NotNull final String category,
    @NotNull final String message,
    @Nullable final String detail
  ) {
    Callback.messageToTable(category, message, detail != null ? detail : "");
  }
}
