package com.yourkit.probes.builtin;

import com.yourkit.probes.*;
import org.jetbrains.annotations.Nullable;

public final class TestNG {
  public static final String TABLE_NAME = "TestNG Method";

  private static final class TestsTable extends Table {
    private final ClassNameColumn myTestClass = new ClassNameColumn("Test Class");
    private final StringColumn myMethod = new StringColumn("Method");

    public TestsTable() {
      super(TestNG.class, TABLE_NAME, Table.MASK_FOR_LASTING_EVENTS);
    }
  }
  private static final TestsTable T_TESTS = new TestsTable();

  @MethodPattern({
    "*test*:@org.testng.annotations.Test *(*)",
    "*Test*:@org.testng.annotations.Test *(*)"
  })
  public static final class Test_Probe {
    public static int onEnter(
      @ClassRef final Class testClass,
      @MethodName final String methodName
    ) {
      final int rowIndex = T_TESTS.createRow();
      T_TESTS.myMethod.setValue(rowIndex, methodName);
      T_TESTS.myTestClass.setValue(rowIndex, testClass);
      return rowIndex;
    }

    public static void onExit(
      @OnEnterResult final int rowIndex,
      @ThrownException @Nullable final Throwable e
    ) {
      T_TESTS.closeRow(rowIndex, e);
    }
  }
}
